"""
Healthdisplay (addons/eventscripts/healthdisplay/healthdisplay.py)
Version: 1.00.001
(C) [#OMEGA] - K2

Agreement

By using this file you agree to the following terms:

This file is delivered 'as-is'. 
I will not take resposibilty for any damage resulting of the use or not-use of this file. 
You use this file with your own risk. 
You are not allowed to share this file and you do not have the permission to use any contents of this file in your own script, unless explicty permitted.
You are not allowed to make profit in any way with this file (e.g. share it as "feature" of your services).
"""

# ##### #
# Psyco #
# ##### #

import psyco
psyco.full()

# ####### #
# Imports #
# ####### #

# Eventscripts Imports
import es
import langlib
import usermsg
import gamethread

# Custom Eventscripts Imports

import pubcvarlib

# Python Imports

import configobj
from validate import Validator

# ################## #
# Global Plugin Data #
# ################## #

# Plugin info

info = es.AddonInfo()
info.name        = "Health display"
info.version     = "1.00.001"
info.author      = "[#OMEGA] - K2"
info.url         = "http://www.german-slaughterhouse.de"
info.description = "Healthdisplay"
info.tags		 = "healthdisplay"

# Globals
gamedir = es.getString('eventscripts_gamedir')

# Language file

lang = langlib.Strings(gamedir + '/addons/eventscripts/healthdisplay/healthdisplay-strings.ini')

# Config File

config = configobj.ConfigObj(gamedir + '/cfg/eventscripts/healthdisplay.ini', configspec=gamedir + '/addons/eventscripts/healthdisplay/healthdisplay-configspec.ini')
errors = configobj.flatten_errors(config, config.validate(Validator(),preserve_errors=True))
if errors:
	es.dbgmsg(0,errors)
	raise ImportError("Invalid Config")
	
# Misc

selfmodule = __import__(__name__)

# ############# #
# Load & Unload #
# ############# #

def load():
	if config['General']['Loop']:
		gamethread.delayedname(config['General']['LoopDelay'],'healthdisplay_loop',DisplayLoop)
		es.addons.registerForEvent(selfmodule, 'es_map_start', event_es_map_start)
	if config['General']['UpdateOnHit']:
		es.addons.registerForEvent(selfmodule, 'player_hurt', event_player_hurt)	
	if config['General']['UpdateOnDeath']:
		es.addons.registerForEvent(selfmodule, 'player_death', event_player_death)
	pubcvarlib.Register('healthdisplay_ver',info.version)
	


def unload():
	if config['General']['Loop']:
		gamethread.cancelDelayed('healthdisplay_loop')
		es.addons.unregisterForEvent(selfmodule, 'es_map_start')
	if config['General']['UpdateOnHit']:
		es.addons.unregisterForEvent(selfmodule, 'player_hurt')
	if config['General']['UpdateOnDeath']:
		es.addons.unregisterForEvent(selfmodule, 'player_death')
		
	pubcvarlib.Unregister('healthdisplay_ver')
	
# ###### #
# Events #
# ###### #

def event_es_map_start(ev):
	gamethread.cancelDelayed('healthdisplay_loop')
	gamethread.delayedname(config['General']['LoopDelay'],'healthdisplay_loop',DisplayLoop)

def event_player_hurt(ev):
	DisplayHealth(int(ev['userid']))

def event_player_death(ev):
	if config['General']['UpdateOnDeath']:
		DisplayHealth()

# ######### #
# Functions #
# ######### #

def DisplayLoop():
	DisplayHealth()
	gamethread.delayedname(config['General']['LoopDelay'],'healthdisplay_loop',DisplayLoop)

def DisplayHealth(userids=None):
	playerlist = es.createplayerlist()
	if userids:
		userids = [userids,]
	else:
		userids = es.getUseridList()
	t_total, t_alive, ct_total, ct_alive = 0,0,0,0
	for player in playerlist:
		if playerlist[player]['teamid'] == 2:
			t_total += 1
			if not playerlist[player]['isdead']:
				t_alive += 1
		elif playerlist[player]['teamid'] == 3:
			ct_total += 1
			if not playerlist[player]['isdead']:
				ct_alive += 1
	for userid in userids:
		player = playerlist[userid]
		language = player['language']
		message = lang('health', {'health': player['health']},language)
		if config['General']['DisplayArmor']:
			message += '\n' + lang('armor', {'armor': player['armor']},language)
		if config['General']['DisplayTeams']:
			message += '\n' + lang('teamdisplay', {'type': lang(config['General']['Team2'],{},language), 'players': t_alive, 'total': t_total},language)
			message += '\n' + lang('teamdisplay', {'type': lang(config['General']['Team3'],{},language), 'players': ct_alive, 'total': ct_total},language)
		if config['General']['DisplayMode'] == 0:
			usermsg.hudhint(userid, message)
		elif config['General']['DisplayMode'] == 1:
			es.menu(10, userid, message, "0123456789")